VERSION 5.00
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "SOAP SDK Echo Tester"
   ClientHeight    =   2940
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   7800
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2940
   ScaleWidth      =   7800
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox cbWSDLURL 
      Height          =   315
      Left            =   660
      TabIndex        =   18
      Top             =   60
      Width           =   7035
   End
   Begin VB.TextBox txtStringLength 
      Alignment       =   1  'Right Justify
      Height          =   315
      Left            =   4020
      TabIndex        =   7
      Text            =   "1"
      Top             =   780
      Width           =   1395
   End
   Begin VB.TextBox txtTestCount 
      Alignment       =   1  'Right Justify
      Height          =   315
      Left            =   4020
      TabIndex        =   5
      Text            =   "2"
      Top             =   420
      Width           =   1395
   End
   Begin VB.CheckBox chkVerifyResult 
      Caption         =   "Verify Result"
      Height          =   255
      Left            =   5520
      TabIndex        =   9
      Top             =   720
      Width           =   2115
   End
   Begin VB.Frame Frame1 
      Caption         =   "Data Type"
      Height          =   1035
      Left            =   60
      TabIndex        =   1
      Top             =   420
      Width           =   2235
      Begin VB.OptionButton optEchoReverseStr 
         Caption         =   "Echo Reverse String"
         Height          =   195
         Left            =   240
         TabIndex        =   2
         Top             =   360
         Value           =   -1  'True
         Width           =   1875
      End
      Begin VB.OptionButton optEchoString 
         Caption         =   "Echo String"
         Height          =   195
         Left            =   240
         TabIndex        =   3
         Top             =   660
         Width           =   1815
      End
   End
   Begin VB.CheckBox chkReuseClient 
      Caption         =   "Reuse Client"
      Height          =   255
      Left            =   5520
      TabIndex        =   8
      Top             =   420
      Value           =   1  'Checked
      Width           =   2115
   End
   Begin VB.Timer tUpdate 
      Enabled         =   0   'False
      Interval        =   1000
      Left            =   4680
      Top             =   1800
   End
   Begin VB.CommandButton cmdStop 
      Caption         =   "Stop"
      Enabled         =   0   'False
      Height          =   435
      Left            =   2820
      TabIndex        =   17
      Top             =   2100
      Width           =   1275
   End
   Begin VB.CommandButton cmdStart 
      Caption         =   "Start"
      Height          =   435
      Left            =   2820
      TabIndex        =   16
      Top             =   1620
      Width           =   1275
   End
   Begin VB.Label lblStringLength 
      Caption         =   "String Length:"
      Height          =   255
      Left            =   2400
      TabIndex        =   6
      Top             =   840
      Width           =   1575
   End
   Begin VB.Label lblTestCount 
      Caption         =   "Test Count:"
      Height          =   255
      Left            =   2400
      TabIndex        =   4
      Top             =   480
      Width           =   1575
   End
   Begin VB.Label lblPerSecond 
      Alignment       =   1  'Right Justify
      Caption         =   "0"
      Height          =   195
      Left            =   1380
      TabIndex        =   15
      Top             =   2280
      Width           =   1275
   End
   Begin VB.Label Label8 
      Caption         =   "Per Second:"
      Height          =   195
      Left            =   60
      TabIndex        =   14
      Top             =   2280
      Width           =   1155
   End
   Begin VB.Line Line1 
      BorderWidth     =   2
      X1              =   0
      X2              =   7740
      Y1              =   1560
      Y2              =   1560
   End
   Begin VB.Label lblSeconds 
      Alignment       =   1  'Right Justify
      Caption         =   "0"
      Height          =   195
      Left            =   1380
      TabIndex        =   13
      Top             =   1980
      Width           =   1275
   End
   Begin VB.Label Label7 
      Caption         =   "Seconds:"
      Height          =   195
      Left            =   60
      TabIndex        =   12
      Top             =   1980
      Width           =   1155
   End
   Begin VB.Label lblCompleteCount 
      Alignment       =   1  'Right Justify
      Caption         =   "0"
      Height          =   195
      Left            =   1380
      TabIndex        =   11
      Top             =   1680
      Width           =   1275
   End
   Begin VB.Label Label4 
      Caption         =   "Complete Count:"
      Height          =   195
      Left            =   60
      TabIndex        =   10
      Top             =   1680
      Width           =   1215
   End
   Begin VB.Label lblWSDLURL 
      Caption         =   "WSDL:"
      Height          =   195
      Left            =   60
      TabIndex        =   0
      Top             =   120
      Width           =   615
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private sglStartTimer As Single
Private sglStopTimer As Single
Private iCompleteCount As Integer
Private bStopped As Boolean
Private bStopRequested As Boolean

Private Sub Form_Load()

    SetForType
    
    cbWSDLURL.AddItem "http://eiffel/Wrox/Service/MyEcho.wsdl"
    cbWSDLURL.AddItem "http://WroxSamples/SoapSamples/Echo/Service/Echo.wsdl"
    
    cbWSDLURL.Text = "http://WroxSamples/SoapSamples/Echo/Service/Echo.wsdl"
    
End Sub

Private Sub SetForType()
    lblStringLength.Enabled = optEchoString.Value
    txtStringLength.Enabled = optEchoString.Value
End Sub

Private Sub cmdStart_Click()

    On Error Resume Next
    
    bStopRequested = False
    cmdStart.Enabled = False
    cmdStop.Enabled = True
    
    If optEchoReverseStr.Value Then
        EchoReverseString
    ElseIf optEchoString.Value Then
        EchoString
    End If
    
    If Err Then
        MsgBox Err.Description, vbExclamation
    End If
    
    bStopped = True
    
    cmdStart.Enabled = True
    cmdStop.Enabled = False

End Sub

Private Sub cmdStop_Click()
    bStopRequested = True
End Sub

Private Sub optEchoReverseStr_Click()
    SetForType
End Sub

Private Sub optEchoString_Click()
    SetForType
End Sub

Private Sub tUpdate_Timer()

    Dim sglTimer As Single
    Dim sglElapsedSeconds As Single
    
    If bStopped Then
        sglTimer = sglStopTimer
        tUpdate.Enabled = False
    Else
        sglTimer = Timer()
    End If
    
    sglElapsedSeconds = sglTimer - sglStartTimer
    
    lblSeconds.Caption = FormatNumber(sglElapsedSeconds, 2, True)
    lblCompleteCount.Caption = iCompleteCount
    lblPerSecond.Caption = FormatNumber(iCompleteCount / sglElapsedSeconds, 2, True)
    
End Sub


Private Sub EchoString()
    
    Dim sc As SoapClient
    Dim iTestCount As Integer
    Dim InputString As String
    Dim ResultString As String
    
    On Error Resume Next
    
    lblCompleteCount.Caption = "0"
    lblSeconds.Caption = "0"
    lblPerSecond.Caption = "0"
    
    InputString = String(CInt(txtStringLength.Text), "1")
    If Err Then
        MsgBox "Invalid string length.", vbExclamation
        Err.Clear
        Exit Sub
    End If
    
    iTestCount = CInt(txtTestCount.Text)
    If Err Then
        MsgBox "Invalid test count.", vbExclamation
        Err.Clear
        Exit Sub
    End If
    
    DoEvents
    
    If chkReuseClient.Value = vbChecked Then
        Set sc = New SoapClient
        sc.mssoapinit cbWSDLURL.Text
        If Err Then
            MsgBox "SoapClient.mssoapinit failed. " & Err.Description, vbExclamation
            Err.Clear
            Exit Sub
        End If
    End If
    
    tUpdate.Enabled = True
    
    DoEvents
    
    bStopped = False
    sglStartTimer = Timer()
    For iCompleteCount = 0 To iTestCount - 1
        If chkReuseClient.Value = vbUnchecked Then
            Set sc = New SoapClient
            sc.mssoapinit cbWSDLURL.Text
            If Err Then
                MsgBox "SoapClient.mssoapinit failed. " & Err.Description, vbExclamation
                Err.Clear
                Exit Sub
            End If
        End If
        ResultString = sc.EchoString(InputString)
        If Err Then
            MsgBox "SoapClient.Echo failed. " & Err.Description & vbCrLf & sc.faultstring & vbCrLf & sc.detail, vbExclamation
            Err.Clear
            Exit Sub
        End If
        If sc.faultcode <> "" Then
            MsgBox "Fault Recieved. " & vbCrLf & sc.faultstring & vbCrLf & sc.detail, vbExclamation
            Exit Sub
        End If
        If chkVerifyResult.Value = vbChecked Then
            If ResultString <> InputString Then
                MsgBox "Incorrect Result Recieved", vbExclamation
                Exit Sub
            End If
        End If
        DoEvents
        If bStopRequested Then Exit For
    Next
    sglStopTimer = Timer()
    bStopped = True
    
End Sub

Private Sub EchoReverseString()
    
    Dim sc As SoapClient
    Dim iTestCount As Integer
    Dim InputString As String
    Dim ResultString As String
    
    On Error Resume Next
    
    lblCompleteCount.Caption = "0"
    lblSeconds.Caption = "0"
    lblPerSecond.Caption = "0"
    
    InputString = String(CInt(txtStringLength.Text), "1")
    If Err Then
        MsgBox "Invalid string length.", vbExclamation
        Err.Clear
        Exit Sub
    End If
    
    iTestCount = CInt(txtTestCount.Text)
    If Err Then
        MsgBox "Invalid test count.", vbExclamation
        Err.Clear
        Exit Sub
    End If
    
    DoEvents
    
    If chkReuseClient.Value = vbChecked Then
        Set sc = New SoapClient
        sc.mssoapinit cbWSDLURL.Text
        If Err Then
            MsgBox "SoapClient.mssoapinit failed. " & Err.Description, vbExclamation
            Err.Clear
            Exit Sub
        End If
    End If
    
    tUpdate.Enabled = True
    
    DoEvents
    
    bStopped = False
    sglStartTimer = Timer()
    For iCompleteCount = 0 To iTestCount - 1
        If chkReuseClient.Value = vbUnchecked Then
            Set sc = New SoapClient
            sc.mssoapinit cbWSDLURL.Text
            If Err Then
                MsgBox "SoapClient.mssoapinit failed. " & Err.Description, vbExclamation
                Err.Clear
                Exit Sub
            End If
        End If
        ResultString = sc.EchoReverseString(InputString)
        If Err Then
            MsgBox "SoapClient.Echo failed. " & Err.Description & vbCrLf & sc.faultstring & vbCrLf & sc.detail, vbExclamation
            Err.Clear
            Exit Sub
        End If
        If sc.faultcode <> "" Then
            MsgBox "Fault Recieved. " & vbCrLf & sc.faultstring & vbCrLf & sc.detail, vbExclamation
            Exit Sub
        End If
        If chkVerifyResult.Value = vbChecked Then
            If StrReverse(ResultString) <> InputString Then
                MsgBox "Incorrect Result Recieved", vbExclamation
                Exit Sub
            End If
        End If
        DoEvents
        If bStopRequested Then Exit For
    Next
    sglStopTimer = Timer()
    bStopped = True
    
End Sub

