import wsdllib
from xml.dom.ext import PrettyPrint

def GenerateExampleWsdl():
    wsdl = wsdllib.Wsdl()
    msg = wsdl.messages.addMessage("GetLastTradePriceInput")
    msg.documentation = "Determine the last available trading price for a listing"
    part = msg.addPart("body", "xsd1:TradePrice")
    return wsdl

wsdl = GenerateExampleWsdl()
doc = wsdl.toDom()
PrettyPrint(doc)
