package wrox.webservices.UDDIImpl;

/**
 * UDDI operator node URLs
 */
public class UDDIOperatorURLs {

  /* URL for UDDI Inquiry in the Production UDDI registry node at IBM       */
  public final static String IBM_INQUIRY_URL_PRODUCTION = "http://www-3.ibm.com/services/uddi/inquiryapi";
  /* URL for UDDI Publish in the Production UDDI registry node at IBM       */
  public final static String IBM_PUBLISH_URL_PRODUCTION = "https://www-3.ibm.com:443/services/uddi/protect/publishapi";

  /* URL for UDDI Inquiry in the Test UDDI registry node at IBM             */
  public final static String IBM_INQUIRY_URL_TEST = "http://www-3.ibm.com/services/uddi/testregistry/inquiryapi";
  /* URL for UDDI Publish in the Test UDDI registry node at IBM             */
  public final static String IBM_PUBLISH_URL_TEST = "https://www-3.ibm.com:443/services/uddi/testregistry/protect/publishapi";

  /* URL for UDDI Inquiry in the Production UDDI registry node at Microsoft */
  public final static String MICROSOFT_INQUIRY_URL_PRODUCTION = "http://uddi.microsoft.com/inquire";
  /* URL for UDDI Publish in the Production UDDI registry node at Microsoft */
  public final static String MICROSOFT_PUBLISH_URL_PRODUCTION = "https://uddi.microsoft.com/publish";

  /* URL for UDDI Inquiry in the Test UDDI registry node at Microsoft       */
  public final static String MICROSOFT_INQUIRY_URL_TEST = "http://test.uddi.microsoft.com/inquire";
  /* URL for UDDI Publish in the Test UDDI registry node at Microsoft       */
  public final static String MICROSOFT_PUBLISH_URL_TEST = "https://test.uddi.microsoft.com/publish";

  /* URL for UDDI Inquiry in the locally installed UDDI registry node       */
  public final static String LOCALHOST_INQUIRY_URL_TEST = "http://localhost:8080/uddi/servlet/uddi";
  /* URL for UDDI Publish in the locally installed UDDI registry node       */
  public final static String LOCALHOST_PUBLISH_URL_TEST = "http://localhost:8080/uddi/servlet/uddi";

}
